<?php

namespace idoit\Module\Search\Query\Protocol;

/**
 * i-doit
 *
 * Query result protocol
 *
 * @package     i-doit
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.com>
 * @version     1.7
 * @copyright   synetics GmbH
 * @license     http://www.i-doit.com/license
 */
interface QueryResultItem
{
    /**
     * Get document Id
     *
     * @return int
     */
    public function getDocumentId();

    /**
     * Get key
     *
     * @return string
     */
    public function getKey();

    /**
     * Return URL to result item
     *
     * @return string
     */
    public function getLink();

    /**
     * @return string
     */
    public function getStatus();

    /**
     * Get matching score
     *
     * @return float
     */
    public function getScore();

    /**
     * Get type (module identifier)
     *
     * @return string
     */
    public function getType();

    /**
     * Get fulltext value
     *
     * @return string
     */
    public function getValue();

    /**
     * QueryResultItem constructor.
     *
     * @param int    $documentId
     * @param string $key
     * @param string $value
     * @param double $score
     */
    public function __construct($documentId, $key, $value, $score, array $conditions);

}
